Index: /trunk/src/Makefile.am
===================================================================
--- /trunk/src/Makefile.am	(revision 5690)
+++ /trunk/src/Makefile.am	(revision 5691)
@@ -116,5 +116,4 @@
                  defs/compiler.h \
                  defs/class_id.h \
-                 defs/functor_list.h \
                  subprojects/benchmark.h
 
Index: /trunk/src/Makefile.in
===================================================================
--- /trunk/src/Makefile.in	(revision 5690)
+++ /trunk/src/Makefile.in	(revision 5691)
@@ -311,5 +311,4 @@
                  defs/compiler.h \
                  defs/class_id.h \
-                 defs/functor_list.h \
                  subprojects/benchmark.h
 
Index: unk/src/defs/functor_list.h
===================================================================
--- /trunk/src/defs/functor_list.h	(revision 5690)
+++ 	(revision )
@@ -1,142 +1,0 @@
-/*
-   orxonox - the future of 3D-vertical-scrollers
-
-   Copyright (C) 2004 orx
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
-   */
-
-/*!
- * @file functors_list.h
- * all the Different types of Functions one can include
-*/
-
-/**
-   useable FunctionParameters are:
-   l_INT:       int
-   l_LONG:      long
-   l_SHORT:     short
-   l_FLOAT:     float
-   l_STRING:    const char*
-   l_XML_ELEM:  TiXmlElement*
- */
-
-#ifndef __FUNCTOR_PARAMETERS__
-#define __FUNCTOR_PARAMETERS__
-
-//! defines the maximum count of arguments function pointers might have
-#define FUNCTOR_MAX_ARGUMENTS                5
-#include "multi_type.h"
-
-#define l_BOOL_TYPE        bool                 //!< The type of an BOOL
-#define l_BOOL_FUNC        isBool               //!< The function to call to parse BOOL
-#define l_BOOL_NAME        "bool"               //!< The name of an BOOL
-#define l_BOOL_PARAM       MT_BOOL              //!< the type of the parameter BOOL
-#define l_BOOL_DEFAULT     false                //!< a default Value for an BOOL
-
-
-#define l_INT_TYPE         int                  //!< The type of an INT
-#define l_INT_FUNC         isInt                //!< The function to call to parse INT
-#define l_INT_NAME         "int"                //!< The name of an INT
-#define l_INT_PARAM        MT_INT               //!< the type of the parameter INT
-#define l_INT_DEFAULT      0                    //!< a default Value for an INT
-
-#define l_UINT_TYPE        unsigned int         //!< The type of an UINT
-#define l_UINT_FUNC        isInt                //!< The function to call to parse UINT
-#define l_UINT_NAME        "unsigned int"       //!< The name of an UINT
-#define l_UINT_PARAM       MT_INT        //!< the type of the parameter UINT
-#define l_UINT_DEFAULT     0                    //!< a default Value for an UINT
-
-#define l_LONG_TYPE        long                 //!< The type of a LONG
-#define l_LONG_FUNC        isInt                //!< The function to parse a LONG
-#define l_LONG_NAME        "long"               //!< The name of a LONG
-#define l_LONG_PARAM       MT_INT //!< the type of the parameter LONG
-#define l_LONG_DEFAULT     0                    //!< a default Value for a LONG
-
-// #define l_SHORT_TYPE       short                //!< The type of a SHORT
-// #define l_SHORT_FUNC       atoi                 //!< The function to parse a SHORT
-// #define l_SHORT_NAME       "short"              //!< The name of a SHORT
-//#define l_SHORT_PARAM       ParameterShort       //!< the type of the parameter SHORT
-// #define l_SHORT_DEFAULT    0                    //!< a default Value for a SHORT
-
-#define l_FLOAT_TYPE       float                //!< The type of a FLOAT
-#define l_FLOAT_FUNC       isFloat              //!< The function to parse a FLOAT
-#define l_FLOAT_NAME       "float"              //!< The name of a FLOAT
-#define l_FLOAT_PARAM      MT_FLOAT             //!< the type of the parameter FLOAT
-#define l_FLOAT_DEFAULT    0.0                  //!< a default Value for a FLOAT
-
-//#define l_VECTOR_TYPE      const Vector&        //!< The type of a VECTOR
-//#define l_VECTOR_FUNC      isVector             //!< The function to parse a VECTOR
-//#define l_VECTOR_NAME      "Vector[x/y/z]"      //!< The name of a VECTOR
-//#define l_VECTOR_DEFAULT   Vector(0,0,0)        //!< Default value for a VECTOR
-
-#define l_STRING_TYPE      const char*          //!< The type of a STRING
-#define l_STRING_FUNC      isString             //!< The function to parse a STRING
-#define l_STRING_NAME      "string"             //!< The name of a STRING
-#define l_STRING_PARAM     MT_STRING            //!< the type of the parameter STRING
-#define l_STRING_DEFAULT   ""                   //!< a default Value for an STRING
-
-#define l_XML_ELEM_TYPE    const TiXmlElement*  //!< The type of an XML_ELEM
-#define l_XML_ELEM_FUNC                         //!< The function to parse an XML_ELEM
-#define l_XML_ELEM_NAME    "XML"                //!< The name of an XML_ELEM
-//#define l_XML_ELEM_PARAM   Parameter            //!< the type of the parameter XML_ELEM
-#define l_XML_ELEM_DEFAULT NULL                 //!< The dafault Value for an XML_ELEM
-
-#endif /* __FUNCTOR_PARAMETERS__ */
-
-
-#ifdef FUNCTOR_LIST
-
-  FUNCTOR_LIST(0)();
-  //! makes functions with one string
-  FUNCTOR_LIST(1)(l_STRING);
-  //! makes functions with two strings
-  FUNCTOR_LIST(2)(l_STRING, l_STRING);
-  //! makes functions with three strings
-  FUNCTOR_LIST(3)(l_STRING, l_STRING, l_STRING);
-  //! makes functions with four strings
-  FUNCTOR_LIST(4)(l_STRING, l_STRING, l_STRING, l_STRING);
-
-  //! makes functions with one bool
-  FUNCTOR_LIST(1)(l_BOOL);
-
-  //! makes functions with one int
-  FUNCTOR_LIST(1)(l_INT);
-  //! makes functions with two ints
-  FUNCTOR_LIST(2)(l_INT, l_INT);
-  //! makes functions with three ints
-  FUNCTOR_LIST(3)(l_INT, l_INT, l_INT);
-  //! makes functions with four ints
-  FUNCTOR_LIST(4)(l_INT, l_INT, l_INT, l_INT);
-
-
-  //! makes functions with one unsigned int
-  FUNCTOR_LIST(1)(l_UINT);
-  //! makes functions with two unsigned ints
-  FUNCTOR_LIST(2)(l_UINT, l_UINT);
-  //! makes functions with three unsigned ints
-  FUNCTOR_LIST(3)(l_UINT, l_UINT, l_UINT);
-  //! makes functions with four unsigned ints
-  FUNCTOR_LIST(4)(l_UINT, l_UINT, l_UINT, l_UINT);
-
-  //! makes functions with one float
-  FUNCTOR_LIST(1)(l_FLOAT);
-  //! makes functions with two floats
-  FUNCTOR_LIST(2)(l_FLOAT, l_FLOAT);
-  //! makes functions with three floats
-  FUNCTOR_LIST(3)(l_FLOAT, l_FLOAT, l_FLOAT);
-  //! makes functions with four floats
-  FUNCTOR_LIST(4)(l_FLOAT, l_FLOAT, l_FLOAT, l_FLOAT);
-  //! makes functions with four floats
-  FUNCTOR_LIST(5)(l_FLOAT, l_FLOAT, l_FLOAT, l_FLOAT, l_FLOAT);
-
-  //! mixed values:
-  FUNCTOR_LIST(2)(l_STRING, l_FLOAT);
-  FUNCTOR_LIST(2)(l_UINT, l_LONG);
-  FUNCTOR_LIST(2)(l_STRING, l_UINT);
-
-
-#endif /* FUNCTOR_LIST */
Index: /trunk/src/lib/Makefile.am
===================================================================
--- /trunk/src/lib/Makefile.am	(revision 5690)
+++ /trunk/src/lib/Makefile.am	(revision 5691)
@@ -60,4 +60,6 @@
                         util/multi_type.h \
                         util/executor/executor.h \
+                        util/executor/executor_specials.h \
+                        util/executor/functor_list.h \
                         math/matrix.h \
                         math/vector.h \
Index: /trunk/src/lib/Makefile.in
===================================================================
--- /trunk/src/lib/Makefile.in	(revision 5690)
+++ /trunk/src/lib/Makefile.in	(revision 5691)
@@ -250,4 +250,6 @@
                         util/multi_type.h \
                         util/executor/executor.h \
+                        util/executor/executor_specials.h \
+                        util/executor/functor_list.h \
                         math/matrix.h \
                         math/vector.h \
Index: /trunk/src/lib/util/executor/executor.h
===================================================================
--- /trunk/src/lib/util/executor/executor.h	(revision 5690)
+++ /trunk/src/lib/util/executor/executor.h	(revision 5691)
@@ -42,5 +42,5 @@
 
     /** executes a Command @param object the object to apply this to @param parameters the parameters the command takes */
-    virtual void execute (BaseObject* object, const void* parameters) = 0;
+    virtual void execute (BaseObject* object, const void* parameters = NULL) = 0;
 
     /** @returns the Type of this Function (either static or objective) */
@@ -261,5 +261,5 @@
     } fp;
 
-    virtual void execute (BaseObject* object, const void* parameters)
+    virtual void execute (BaseObject* object, const void* parameters = NULL)
     {
       SubString sub((const char*) parameters, " \n\t,", '\\');
@@ -323,5 +323,5 @@
 
 
-    virtual void execute (BaseObject* object, const void* parameters)
+    virtual void execute (BaseObject* object, const void* parameters = NULL)
     {
   SubString sub((const char*)parameters, " \n\t,");
Index: /trunk/src/lib/util/executor/executor_specials.h
===================================================================
--- /trunk/src/lib/util/executor/executor_specials.h	(revision 5690)
+++ /trunk/src/lib/util/executor/executor_specials.h	(revision 5691)
@@ -59,5 +59,5 @@
      * @param loadString ignored in this case
      */
-    virtual void execute(BaseObject* object, const void* loadString)
+    virtual void execute(BaseObject* object, const void* parameters = NULL)
     {
       if (object != NULL && this->element != NULL)
Index: /trunk/src/lib/util/executor/functor_list.h
===================================================================
--- /trunk/src/lib/util/executor/functor_list.h	(revision 5691)
+++ /trunk/src/lib/util/executor/functor_list.h	(revision 5691)
@@ -0,0 +1,142 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+   */
+
+/*!
+ * @file functors_list.h
+ * all the Different types of Functions one can include
+*/
+
+/**
+   useable FunctionParameters are:
+   l_INT:       int
+   l_LONG:      long
+   l_SHORT:     short
+   l_FLOAT:     float
+   l_STRING:    const char*
+   l_XML_ELEM:  TiXmlElement*
+ */
+
+#ifndef __FUNCTOR_PARAMETERS__
+#define __FUNCTOR_PARAMETERS__
+
+//! defines the maximum count of arguments function pointers might have
+#define FUNCTOR_MAX_ARGUMENTS                5
+#include "multi_type.h"
+
+#define l_BOOL_TYPE        bool                 //!< The type of an BOOL
+#define l_BOOL_FUNC        isBool               //!< The function to call to parse BOOL
+#define l_BOOL_NAME        "bool"               //!< The name of an BOOL
+#define l_BOOL_PARAM       MT_BOOL              //!< the type of the parameter BOOL
+#define l_BOOL_DEFAULT     false                //!< a default Value for an BOOL
+
+
+#define l_INT_TYPE         int                  //!< The type of an INT
+#define l_INT_FUNC         isInt                //!< The function to call to parse INT
+#define l_INT_NAME         "int"                //!< The name of an INT
+#define l_INT_PARAM        MT_INT               //!< the type of the parameter INT
+#define l_INT_DEFAULT      0                    //!< a default Value for an INT
+
+#define l_UINT_TYPE        unsigned int         //!< The type of an UINT
+#define l_UINT_FUNC        isInt                //!< The function to call to parse UINT
+#define l_UINT_NAME        "unsigned int"       //!< The name of an UINT
+#define l_UINT_PARAM       MT_INT        //!< the type of the parameter UINT
+#define l_UINT_DEFAULT     0                    //!< a default Value for an UINT
+
+#define l_LONG_TYPE        long                 //!< The type of a LONG
+#define l_LONG_FUNC        isInt                //!< The function to parse a LONG
+#define l_LONG_NAME        "long"               //!< The name of a LONG
+#define l_LONG_PARAM       MT_INT //!< the type of the parameter LONG
+#define l_LONG_DEFAULT     0                    //!< a default Value for a LONG
+
+// #define l_SHORT_TYPE       short                //!< The type of a SHORT
+// #define l_SHORT_FUNC       atoi                 //!< The function to parse a SHORT
+// #define l_SHORT_NAME       "short"              //!< The name of a SHORT
+//#define l_SHORT_PARAM       ParameterShort       //!< the type of the parameter SHORT
+// #define l_SHORT_DEFAULT    0                    //!< a default Value for a SHORT
+
+#define l_FLOAT_TYPE       float                //!< The type of a FLOAT
+#define l_FLOAT_FUNC       isFloat              //!< The function to parse a FLOAT
+#define l_FLOAT_NAME       "float"              //!< The name of a FLOAT
+#define l_FLOAT_PARAM      MT_FLOAT             //!< the type of the parameter FLOAT
+#define l_FLOAT_DEFAULT    0.0                  //!< a default Value for a FLOAT
+
+//#define l_VECTOR_TYPE      const Vector&        //!< The type of a VECTOR
+//#define l_VECTOR_FUNC      isVector             //!< The function to parse a VECTOR
+//#define l_VECTOR_NAME      "Vector[x/y/z]"      //!< The name of a VECTOR
+//#define l_VECTOR_DEFAULT   Vector(0,0,0)        //!< Default value for a VECTOR
+
+#define l_STRING_TYPE      const char*          //!< The type of a STRING
+#define l_STRING_FUNC      isString             //!< The function to parse a STRING
+#define l_STRING_NAME      "string"             //!< The name of a STRING
+#define l_STRING_PARAM     MT_STRING            //!< the type of the parameter STRING
+#define l_STRING_DEFAULT   ""                   //!< a default Value for an STRING
+
+#define l_XML_ELEM_TYPE    const TiXmlElement*  //!< The type of an XML_ELEM
+#define l_XML_ELEM_FUNC                         //!< The function to parse an XML_ELEM
+#define l_XML_ELEM_NAME    "XML"                //!< The name of an XML_ELEM
+//#define l_XML_ELEM_PARAM   Parameter            //!< the type of the parameter XML_ELEM
+#define l_XML_ELEM_DEFAULT NULL                 //!< The dafault Value for an XML_ELEM
+
+#endif /* __FUNCTOR_PARAMETERS__ */
+
+
+#ifdef FUNCTOR_LIST
+
+  FUNCTOR_LIST(0)();
+  //! makes functions with one string
+  FUNCTOR_LIST(1)(l_STRING);
+  //! makes functions with two strings
+  FUNCTOR_LIST(2)(l_STRING, l_STRING);
+  //! makes functions with three strings
+  FUNCTOR_LIST(3)(l_STRING, l_STRING, l_STRING);
+  //! makes functions with four strings
+  FUNCTOR_LIST(4)(l_STRING, l_STRING, l_STRING, l_STRING);
+
+  //! makes functions with one bool
+  FUNCTOR_LIST(1)(l_BOOL);
+
+  //! makes functions with one int
+  FUNCTOR_LIST(1)(l_INT);
+  //! makes functions with two ints
+  FUNCTOR_LIST(2)(l_INT, l_INT);
+  //! makes functions with three ints
+  FUNCTOR_LIST(3)(l_INT, l_INT, l_INT);
+  //! makes functions with four ints
+  FUNCTOR_LIST(4)(l_INT, l_INT, l_INT, l_INT);
+
+
+  //! makes functions with one unsigned int
+  FUNCTOR_LIST(1)(l_UINT);
+  //! makes functions with two unsigned ints
+  FUNCTOR_LIST(2)(l_UINT, l_UINT);
+  //! makes functions with three unsigned ints
+  FUNCTOR_LIST(3)(l_UINT, l_UINT, l_UINT);
+  //! makes functions with four unsigned ints
+  FUNCTOR_LIST(4)(l_UINT, l_UINT, l_UINT, l_UINT);
+
+  //! makes functions with one float
+  FUNCTOR_LIST(1)(l_FLOAT);
+  //! makes functions with two floats
+  FUNCTOR_LIST(2)(l_FLOAT, l_FLOAT);
+  //! makes functions with three floats
+  FUNCTOR_LIST(3)(l_FLOAT, l_FLOAT, l_FLOAT);
+  //! makes functions with four floats
+  FUNCTOR_LIST(4)(l_FLOAT, l_FLOAT, l_FLOAT, l_FLOAT);
+  //! makes functions with four floats
+  FUNCTOR_LIST(5)(l_FLOAT, l_FLOAT, l_FLOAT, l_FLOAT, l_FLOAT);
+
+  //! mixed values:
+  FUNCTOR_LIST(2)(l_STRING, l_FLOAT);
+  FUNCTOR_LIST(2)(l_UINT, l_LONG);
+  FUNCTOR_LIST(2)(l_STRING, l_UINT);
+
+
+#endif /* FUNCTOR_LIST */
Index: /trunk/src/util/loading/load_param.cc
===================================================================
--- /trunk/src/util/loading/load_param.cc	(revision 5690)
+++ /trunk/src/util/loading/load_param.cc	(revision 5691)
@@ -15,6 +15,4 @@
 
 #define DEBUG_SPECIAL_MODULE DEBUG_MODULE_LOADING
-
-#include "functor_list.h"
 
 #include "load_param.h"
Index: /trunk/src/util/loading/load_param_description.cc
===================================================================
--- /trunk/src/util/loading/load_param_description.cc	(revision 5690)
+++ /trunk/src/util/loading/load_param_description.cc	(revision 5691)
@@ -16,9 +16,8 @@
 #include "load_param_description.h"
 
+#include "multi_type.h"
 #include "list.h"
 #include <stdarg.h>
 #include "stdlibincl.h"
-#include "functor_list.h"
-
 /**
  * @param paramName the name of the parameter to load