Index: branches/collision_detection/src/lib/collision_detection/obb_tree_node.cc
===================================================================
--- branches/collision_detection/src/lib/collision_detection/obb_tree_node.cc	(revision 5710)
+++ branches/collision_detection/src/lib/collision_detection/obb_tree_node.cc	(revision 5711)
@@ -42,5 +42,5 @@
  *  standard constructor
  */
-OBBTreeNode::OBBTreeNode (const OBBTree* tree) 
+OBBTreeNode::OBBTreeNode (const OBBTree* tree)
   : BVTreeNode()
 {
@@ -111,5 +111,5 @@
  * on the triangle informations (triangle soup not polygon soup)
  */
-void OBBTreeNode::spawnBVTree(const int depth, const modelInfo& modelInf, 
+void OBBTreeNode::spawnBVTree(const int depth, const modelInfo& modelInf,
                               const int* triangleIndexes, unsigned int length)
 {
@@ -119,9 +119,9 @@
   this->depth = depth;
 
-  this->bvElement = new OBB();  
+  this->bvElement = new OBB();
   this->bvElement->modelInf = &modelInf;
   this->bvElement->triangleIndexes = triangleIndexes;
   this->bvElement->numTriangles = length;
-  
+
   /* create the boxes in three steps */
   this->calculateBoxCovariance(this->bvElement, modelInf, triangleIndexes, length);
@@ -173,6 +173,6 @@
 //   PRINTF(3)("OBB Depth: %i, tree index: %i, numVertices: %i\n", depth, treeIndex, length);
 //   this->depth = depth;
-// 
-// 
+//
+//
 //   this->bvElement = new OBB();
 //   this->bvElement->vertices = verticesList;
@@ -185,12 +185,12 @@
 //   this->calculateBoxAxis(this->bvElement, verticesList, length);
 //   PRINTF(3)("Calculated attributes3\n");
-// 
-// 
-// 
+//
+//
+//
 //   if( likely( this->depth > 0))
 //   {
 //     this->forkBox(this->bvElement);
-// 
-// 
+//
+//
 //     if(this->tmpLen1 > 2)
 //     {
@@ -203,5 +203,5 @@
 //       PRINTF(3)("Aboarding tree walk: less than 3 vertices left\n");
 //     }
-// 
+//
 //     if( this->tmpLen2 > 2)
 //     {
@@ -218,11 +218,11 @@
 
 
-void OBBTreeNode::calculateBoxCovariance(OBB* box, const modelInfo& modelInf, 
+void OBBTreeNode::calculateBoxCovariance(OBB* box, const modelInfo& modelInf,
                                          const int* triangleIndexes, unsigned int length)
 {
   const sVec3D* verticesList;
-  
+
   PRINTF(3)("Created OBBox\n");
-  
+
   float     facelet[length];                         //!< surface area of the i'th triangle of the convex hull
   float     face = 0.0f;                             //!< surface area of the entire convex hull
@@ -235,5 +235,5 @@
 
 
- 
+
   /* fist compute all the convex hull face/facelets and centroids */
   for( int i = 0; i < length ; ++i)
@@ -262,5 +262,5 @@
 
 
-  /* now calculate the covariance matrix - if not written in three for-loops, 
+  /* now calculate the covariance matrix - if not written in three for-loops,
      it would compute faster: minor */
   for( int j = 0; j < 3; ++j)
@@ -281,5 +281,5 @@
   PRINTF(3)("-- Calculated Covariance\n");
 
-    
+
   PRINTF(3)("\nVertex Data:\n");
   for(int i = 0; i < length; i++)
@@ -297,10 +297,10 @@
   }
   box->center = center;
-  
+
   PRINTF(3)("-- Written Result to OBB\n");
 }
 
 
-void OBBTreeNode::calculateBoxEigenvectors(OBB* box, const modelInfo& modInfo, 
+void OBBTreeNode::calculateBoxEigenvectors(OBB* box, const modelInfo& modInfo,
                                            const int* triangleIndexes, unsigned int length)
 {}
@@ -640,4 +640,7 @@
 bool OBBTreeNode::overlapTest(OBB* boxA, OBB* boxB, WorldEntity* nodeA, WorldEntity* nodeB)
 {
+  if( boxB == NULL || boxA == NULL)
+    return false;
+
   /* first check all axis */
   Vector t;
Index: branches/collision_detection/src/lib/event/Makefile.in
===================================================================
--- branches/collision_detection/src/lib/event/Makefile.in	(revision 5710)
+++ branches/collision_detection/src/lib/event/Makefile.in	(revision 5711)
@@ -210,7 +210,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/lib/event/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/lib/event/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --gnu  src/lib/event/Makefile
+	  $(AUTOMAKE) --foreign  src/lib/event/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: branches/collision_detection/src/lib/graphics/Makefile.in
===================================================================
--- branches/collision_detection/src/lib/graphics/Makefile.in	(revision 5710)
+++ branches/collision_detection/src/lib/graphics/Makefile.in	(revision 5711)
@@ -227,7 +227,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/lib/graphics/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/lib/graphics/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --gnu  src/lib/graphics/Makefile
+	  $(AUTOMAKE) --foreign  src/lib/graphics/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: branches/collision_detection/src/lib/graphics/importer/Makefile.in
===================================================================
--- branches/collision_detection/src/lib/graphics/importer/Makefile.in	(revision 5710)
+++ branches/collision_detection/src/lib/graphics/importer/Makefile.in	(revision 5711)
@@ -214,7 +214,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/lib/graphics/importer/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/lib/graphics/importer/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --gnu  src/lib/graphics/importer/Makefile
+	  $(AUTOMAKE) --foreign  src/lib/graphics/importer/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: branches/collision_detection/src/lib/graphics/spatial_separation/Makefile.in
===================================================================
--- branches/collision_detection/src/lib/graphics/spatial_separation/Makefile.in	(revision 5710)
+++ branches/collision_detection/src/lib/graphics/spatial_separation/Makefile.in	(revision 5711)
@@ -204,7 +204,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/lib/graphics/spatial_separation/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/lib/graphics/spatial_separation/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --gnu  src/lib/graphics/spatial_separation/Makefile
+	  $(AUTOMAKE) --foreign  src/lib/graphics/spatial_separation/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: branches/collision_detection/src/lib/gui/Makefile.in
===================================================================
--- branches/collision_detection/src/lib/gui/Makefile.in	(revision 5710)
+++ branches/collision_detection/src/lib/gui/Makefile.in	(revision 5711)
@@ -183,7 +183,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/lib/gui/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/lib/gui/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --gnu  src/lib/gui/Makefile
+	  $(AUTOMAKE) --foreign  src/lib/gui/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: branches/collision_detection/src/lib/gui/gl_gui/Makefile.in
===================================================================
--- branches/collision_detection/src/lib/gui/gl_gui/Makefile.in	(revision 5710)
+++ branches/collision_detection/src/lib/gui/gl_gui/Makefile.in	(revision 5711)
@@ -230,7 +230,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/lib/gui/gl_gui/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/lib/gui/gl_gui/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --gnu  src/lib/gui/gl_gui/Makefile
+	  $(AUTOMAKE) --foreign  src/lib/gui/gl_gui/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: branches/collision_detection/src/lib/gui/gtk_gui/Makefile.in
===================================================================
--- branches/collision_detection/src/lib/gui/gtk_gui/Makefile.in	(revision 5710)
+++ branches/collision_detection/src/lib/gui/gtk_gui/Makefile.in	(revision 5711)
@@ -232,7 +232,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/lib/gui/gtk_gui/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/lib/gui/gtk_gui/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --gnu  src/lib/gui/gtk_gui/Makefile
+	  $(AUTOMAKE) --foreign  src/lib/gui/gtk_gui/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: branches/collision_detection/src/lib/particles/Makefile.in
===================================================================
--- branches/collision_detection/src/lib/particles/Makefile.in	(revision 5710)
+++ branches/collision_detection/src/lib/particles/Makefile.in	(revision 5711)
@@ -207,7 +207,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/lib/particles/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/lib/particles/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --gnu  src/lib/particles/Makefile
+	  $(AUTOMAKE) --foreign  src/lib/particles/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: branches/collision_detection/src/lib/physics/Makefile.in
===================================================================
--- branches/collision_detection/src/lib/physics/Makefile.in	(revision 5710)
+++ branches/collision_detection/src/lib/physics/Makefile.in	(revision 5711)
@@ -215,7 +215,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/lib/physics/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/lib/physics/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --gnu  src/lib/physics/Makefile
+	  $(AUTOMAKE) --foreign  src/lib/physics/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: branches/collision_detection/src/lib/shell/Makefile.in
===================================================================
--- branches/collision_detection/src/lib/shell/Makefile.in	(revision 5710)
+++ branches/collision_detection/src/lib/shell/Makefile.in	(revision 5711)
@@ -211,7 +211,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/lib/shell/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/lib/shell/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --gnu  src/lib/shell/Makefile
+	  $(AUTOMAKE) --foreign  src/lib/shell/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: branches/collision_detection/src/lib/sound/Makefile.in
===================================================================
--- branches/collision_detection/src/lib/sound/Makefile.in	(revision 5710)
+++ branches/collision_detection/src/lib/sound/Makefile.in	(revision 5711)
@@ -207,7 +207,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/lib/sound/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/lib/sound/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --gnu  src/lib/sound/Makefile
+	  $(AUTOMAKE) --foreign  src/lib/sound/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: branches/collision_detection/src/lib/tinyxml/Makefile.in
===================================================================
--- branches/collision_detection/src/lib/tinyxml/Makefile.in	(revision 5710)
+++ branches/collision_detection/src/lib/tinyxml/Makefile.in	(revision 5711)
@@ -203,7 +203,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/lib/tinyxml/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/lib/tinyxml/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --gnu  src/lib/tinyxml/Makefile
+	  $(AUTOMAKE) --foreign  src/lib/tinyxml/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: branches/collision_detection/src/subprojects/Makefile.in
===================================================================
--- branches/collision_detection/src/subprojects/Makefile.in	(revision 5710)
+++ branches/collision_detection/src/subprojects/Makefile.in	(revision 5711)
@@ -190,7 +190,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/subprojects/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/subprojects/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --gnu  src/subprojects/Makefile
+	  $(AUTOMAKE) --foreign  src/subprojects/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: branches/collision_detection/src/subprojects/collision_detection/Makefile.in
===================================================================
--- branches/collision_detection/src/subprojects/collision_detection/Makefile.in	(revision 5710)
+++ branches/collision_detection/src/subprojects/collision_detection/Makefile.in	(revision 5711)
@@ -250,7 +250,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/subprojects/collision_detection/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/subprojects/collision_detection/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --gnu  src/subprojects/collision_detection/Makefile
+	  $(AUTOMAKE) --foreign  src/subprojects/collision_detection/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: branches/collision_detection/src/subprojects/importer/Makefile.in
===================================================================
--- branches/collision_detection/src/subprojects/importer/Makefile.in	(revision 5710)
+++ branches/collision_detection/src/subprojects/importer/Makefile.in	(revision 5711)
@@ -233,7 +233,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/subprojects/importer/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/subprojects/importer/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --gnu  src/subprojects/importer/Makefile
+	  $(AUTOMAKE) --foreign  src/subprojects/importer/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: branches/collision_detection/src/subprojects/particles/Makefile.in
===================================================================
--- branches/collision_detection/src/subprojects/particles/Makefile.in	(revision 5710)
+++ branches/collision_detection/src/subprojects/particles/Makefile.in	(revision 5711)
@@ -253,7 +253,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/subprojects/particles/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/subprojects/particles/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --gnu  src/subprojects/particles/Makefile
+	  $(AUTOMAKE) --foreign  src/subprojects/particles/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: branches/collision_detection/src/subprojects/testmain/Makefile.in
===================================================================
--- branches/collision_detection/src/subprojects/testmain/Makefile.in	(revision 5710)
+++ branches/collision_detection/src/subprojects/testmain/Makefile.in	(revision 5711)
@@ -197,7 +197,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/subprojects/testmain/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/subprojects/testmain/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --gnu  src/subprojects/testmain/Makefile
+	  $(AUTOMAKE) --foreign  src/subprojects/testmain/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
Index: branches/collision_detection/src/util/Makefile.in
===================================================================
--- branches/collision_detection/src/util/Makefile.in	(revision 5710)
+++ branches/collision_detection/src/util/Makefile.in	(revision 5711)
@@ -235,7 +235,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/util/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/util/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --gnu  src/util/Makefile
+	  $(AUTOMAKE) --foreign  src/util/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status